<cfsetting enableCFOutputOnly="TRUE">
<!---
	CFTree
	Author:	Mike Nimer
--->
<cfswitch expression="#thisTag.executionMode#">
	<cfcase value="Start">

		<cfsetting enableCFOutputOnly="FALSE"><cfsilent>
		
		<!--- check for cfform ancestor --->
		<cfif not listFind(getBaseTagList(), "CFFORM")>
			<cfobject action="create" type="java" class="coldfusion.tagext.validation.MissingAncestorTagException" name="ex">
			<cfset ex.init("CFTree", "CFForm")>
			<cfthrow object="#ex#">
		</cfif>
		<cfif listValueCount(getBaseTagList(), "CFTREE") gt 1>
			<cfobject action="create" type="java" class="coldfusion.tagext.validation.SelfNestedTagException" name="ex">
			<cfset ex.init("CFTree")>
			<cfthrow object="#ex#">
		</cfif>
	
		<!--- Attribute defaults --->	
		<cfparam name="attributes.required" default="No">
		<cfparam name="attributes.delimiter" default="\">
		<cfparam name="attributes.appendkey" default="Yes">
		<cfparam name="attributes.highlighthref" default="Yes">
		<cfparam name="attributes.italic" default="No">
		<cfparam name="attributes.bold" default="No">
		<cfparam name="attributes.height" default="320">
		<cfparam name="attributes.width" default="200">
		<cfparam name="attributes.border" default="Yes">
		<cfparam name="attributes.hScroll" default="Yes">
		<cfparam name="attributes.vScroll" default="Yes">
		<cfparam name="attributes.notsupported" default="<B>Browser must support Java to <BR> view ColdFusion Java Applets!</B>">
		
		<cfif structKeyExists(attributes, "lookandfeel")>
		   <cfset lLookandFeel="MOTIF,WINDOWS,METAL">
		   <cfif not ListFindNoCase(lLookandFeel,attributes.lookandfeel)>
		      <cfobject action="create" type="java" class="coldfusion.tagext.validation.IllegalSwitchValueException" name="ex">
			  <cfset ex.init("CFTree", "LookAndFeel", attributes.lookAndFeel, listToArray(lLookandFeel))>
			  <cfthrow object="#ex#">
		   </cfif>
		</cfif>
		<cfif structKeyExists(attributes, "align")>
		   <cfset lAlign="LEFT,RIGHT,BOTTOM,TEXTTOP,MIDDLE,ABSMIDDLE,BASELINE,ABSBOTTOM,TOP">
		   <cfif not ListFindNoCase(lAlign,attributes.align)>
		      <cfobject action="create" type="java" class="coldfusion.tagext.validation.IllegalSwitchValueException" name="ex">
			  <cfset ex.init("CFTree", "Alighn", attributes.lookAndFeel, listToArray(lAlign))>
			  <cfthrow object="#ex#">
		   </cfif>
		</cfif>
		
		<cfscript>
			//Get base tag - CFForm data
			stCFFormData = getBaseTagData("CFform");
	
			cfFormName = stCFFormData.attributes.name;
			hiddenFieldName = "__CFTREE__#cfFormName#__#attributes.name#";
			
			stCFFormData.stFunctions.setFormVar = 1; // common JS function it needs
			
			arrayAppend(stCFFormData.aHiddenFields, hiddenFieldName);
			// onValidate script
				if( structKeyExists(attributes, "onValidate") ) {
				
					stCFFormData.stFunctions.onError = 1; // common JS function (default error handler function)
					// add to stControlScripts in cfform
					stControlScript = structNew();
					stControlScript.formField = hiddenFieldName;
					stControlScript.aErrorExpressions = arrayNew(1);		
					stControlScript.aErrorExpressions[1] = "!#attributes.onValidate#(_CF_this, _CF_this.#hiddenFieldName#, _CF_this.#hiddenFieldName#.value)";
					if( structKeyExists(attributes, "onError") )
						stControlScript.onErrorFunction = attributes.onError;
					if( structKeyExists(attributes, "message") )
						stControlScript.errorMessageText = attributes.message;					
					stCFFormData.stControlScripts[attributes.name] = stControlScript;
        		    ArrayAppend(stCFFormData.arValidateOrder, attributes.name);
				}	
				
				if( attributes.required )
				{
					stCFFormData.stFunctions.onError = 1;
					stCFFormData.stFunctions.required = 1;
					stControlScript = structNew();
					stControlScript.formField = hiddenFieldName;
				
					if( structKeyExists(attributes, "onError") )
						stControlScript.onErrorFunction = attributes.onError;
					if( structKeyExists(attributes, "message") )
						stControlScript.errorMessageText = attributes.message;
					else
						stControlScript.errorMessageText = "Error in #hiddenFieldName# value.";
	
					stControlScript.aErrorExpressions = arrayNew(1);
					stControlScript.aErrorExpressions[1] = '!_CF_hasValue(_CF_this.#hiddenFieldName#, "TEXT" )';
					stCFFormData.stControlScripts[attributes.name] = stControlScript;
		            ArrayAppend(stCFFormData.arValidateOrder, attributes.name);
				}
			
			
			//preserve data function
			if( stCFFormData.attributes.preserveData and structKeyExists(form, attributes.name) and structKeyExists(form[attributes.name], "path") )
			{
				attributes.value = form[attributes.name].path;
			}
			
			//create string buffer
			TreeItems = createObject("java", "java.lang.StringBuffer");
		</cfscript>

		</cfsilent><cfsetting enableCFOutputOnly="TRUE">

	</cfcase>
	
	
	
	
	
	<cfcase value="End">
		<cfsetting enableCFOutputOnly="FALSE"><cfsilent>
<!--- ::	
	* build heirarchy tree
	:: --->
<cfset startTime = getTickCount()>
<cfset CFTreeHelper = createObject("java", "coldfusion.runtime.CFTreeHelper")>

<cfif isDefined("thistag.assocattribs")>
<cfscript>
	/*
	* build parent child query out of single <cftreeitem> tags - not the tags with query attributes.
	*/
t1 = getTickCount();
	nodeArray = arrayNew(1);
	itemsQuery = querynew("value,treevalue,display,parent,img,imgopen,href,target,expand");

	attribsLen = arrayLen(thistag.assocattribs);
	for( i=1; i lte attribsLen; i=i+1)
	{
		thisItem = thistag.assocattribs[i];
		if( not isDefined("thisItem.query") )
		{
			queryAddRow(itemsQuery);
			querySetCell(itemsQuery, "value", javacast("String", thisItem.value));
			querySetCell(itemsQuery, "treevalue", javacast("String", thisItem.value));
			querySetCell(itemsQuery, "display", javacast("String", thisItem.display));
			querySetCell(itemsQuery, "parent", javacast("String", thisItem.parent));
			querySetCell(itemsQuery, "img", javacast("String", thisItem.img));
			querySetCell(itemsQuery, "imgopen", javacast("String", thisItem.imgopen));
			querySetCell(itemsQuery, "href", javacast("String", thisItem.href));
			querySetCell(itemsQuery, "target", javacast("String", thisItem.target));
			querySetCell(itemsQuery, "expand", javacast("String", thisItem.expand));
		}
	}
t1 = getTickCount() - t1;
writeoutput("cfml build query: #t1#ms <br>");

	//
	// convert the query generated above into a struct, one for each node/item
	//
	st = structNew();
	st['root'] = structNew();
	st['root'].value = 'root';
	st['root'].treevalue = 'root';
	st['root'].display = 'root';
	st['root'].parent = "";
	st['root'].img = listFirst(thisItem.img);
	st['root'].imgopen = listFirst(thisItem.imgopen);
	st['root'].href = listFirst(thisItem.href);
	st['root'].target = listFirst(thisItem.target);
	st['root'].expand = listFirst(thisItem.expand);
	st['root'].children = arrayNew(1);
	st['root'].stchildren = structNew();
	

t1 = getTickCount();
	//
	// convert the query generated above into a struct, one for each node/item
	//
	tree = CFTreeHelper.query2map(structNew(),itemsQuery,"value","treevalue","display","parent",true,"img","imgopen","href","target","expand");
t1 = getTickCount() - t1;
writeoutput("java query2map: #t1#ms<br>");


t1 = getTickCount();
	//
	//	take the struct of items and define the relationships between the children and the parents.
	//
	singletree = CFTreeHelper.defineRelationShips(tree, itemsQuery);
t1 = getTickCount() - t1;
writeoutput("java define relationships: #t1#ms<br>");


	/*
	*	Build parent child of query <cftreeItem>. What makes this different then the single <cftreeitem> is how the heirarchy is defined.
	* 	In The single mode there is a different item for each node. With the query there is a csv list, for example
	*
	* 	a heirarchy that looks like this
	*	dept
	*		manager
	*			user
	*	Will be defined in the tag as a comma separate list of columns.
	*	dept,manager,user
	*/
	aQueryTrees = arrayNew(1);
	attribsLen = arrayLen(thistag.assocattribs);
	for( i=1; i lte attribsLen; i=i+1)
	{
		aLevels = arrayNew(1);
		thisItem = thistag.assocattribs[i];
		if( isDefined("thisItem.query") )
		{
			aValues = listToArray(thisItem.value);
			aDisplay = listToArray(thisItem.display);
			aImg = listToArray(thisItem.img);
			aImgOpen = listToArray(thisItem.imgopen);
			aHref = listToArray(thisItem.href);
			aTarget = listToArray(thisItem.target);
			aExpand = listToArray(thisItem.expand);
			//build root node, which is the name of the query. This is used if queryasroot="true"
			st = structNew();
			st[thisItem.query] = structNew();
			st[thisItem.query].value = thisItem.query;
			st[thisItem.query].display = thisItem.query;
			st[thisItem.query].parent = "";
			st[thisItem.query].img = listFirst(thisItem.img);
			st[thisItem.query].imgopen = listFirst(thisItem.imgopen);
			st[thisItem.query].href = listFirst(thisItem.href);
			st[thisItem.query].target = listFirst(thisItem.target);
			st[thisItem.query].expand = listFirst(thisItem.expand);
			st[thisItem.query].children = arrayNew(1);
			st[thisItem.query].stchildren = structNew();

		// hf53398 - Make sure the Expand array has entries for all levels.
		//			If this query is the root - pop the first img, imgopen, and expand off the list because they
		//			were used for the root.
		
			while (ArrayLen(aExpand) LE ArrayLen(aValues)) {
				if (ArrayLen(aExpand) EQ 0) {	ArrayAppend( aExpand, "Yes" );  }
				else 						{	ArrayAppend( aExpand, listLast(thisItem.expand)); }
			}
			if (thisItem.queryasroot) {
				if (ArrayLen(aImg) GT 1) 		ArrayDeleteAt( aImg, 1 );
				if (ArrayLen(aImgOpen) GT 1) 	ArrayDeleteAt( aImgOpen, 1 );
				if (ArrayLen(aExpand) GT 1) 	ArrayDeleteAt( aExpand, 1 );
			}

			// hf53398 end

			t1 = getTickCount();
				st = CFTreeHelper.query2map(st, caller[thisItem.query], thisItem.query, aValues, aDisplay, aImg, aImgOpen, ahref, aTarget, aExpand);
				aQueryTrees.add(st);
			t1 = getTickCount() - t1;
			writeoutput("java query2map: #t1#ms <br> ");
			//dump(st);

		}
	}




	/*
	* go through all the nodes and compare them to the <cftreeitem> tags to determine the roots for cftree.
	*/
t1 = getTickCount();
	aRootItems =  CFTreeHelper.getRootElements(thistag.assocattribs, aQueryTrees, singleTree, valueList(itemsQuery.value));
t1 = getTickCount() - t1;
writeoutput("java get root elements: #t1#ms <br> ");
	//dump(aRootItems);
	/*
	* generate a cftrr compatable string from our tree dataobject
	*/ 
t1 = getTickCount();
	treeItems =  CFTreeHelper.getCFTreeString(aRootItems);
t1 = getTickCount() - t1;
writeoutput("java get cftree string: #t1#ms <br> ");

</cfscript>
<cfset endTime = getTickCount() - starttime>
<cfoutput>total: #endTime#ms <br></cfoutput>


<cfelse>
	<cfset treeItems = "">
</cfif>


<!--- ::	
	* generate output
	:: --->
		<cfscript>			
			// determine browser
			if( cgi.HTTP_USER_AGENT contains "MSIE" )
				{ bIE = 1;} 
			else 
				{ bIE = 0;	}
			
			// get codebase & archive from cfform
			if( structKeyExists(stCFFormData.attributes, "codebase") )
				{ codeBase = stCFFormData.attributes.codebase; }
			else
				{ codeBase = "#getpageContext().getRequest().getContextPath()#/CFIDE/classes/cf-j2re-win.cab"; }
			
			if( structKeyExists(stCFFormData.attributes, "archive") )
				{ archive = stCFFormData.attributes.archive; }
			else
				{ archive = "#getpageContext().getRequest().getContextPath()#/CFIDE/classes/cfapplets.jar"; }
		</cfscript>

		</cfsilent><cfsetting enableCFOutputOnly="TRUE">
<!-- Applet call for IE -->

<cfif bIE>
	<cfoutput>
<OBJECT
	CLASSID="clsid:8AD9C840-044E-11D1-B3E9-00805F499D93"
	CODEBASE="#codeBase#"
</cfoutput>  
		<cfif not isNumeric(attributes.width) or attributes.width gt 0>
			<cfoutput>	WIDTH="#attributes.width#"#Chr(13)#</cfoutput>
		</cfif>
		<cfif not isNumeric(attributes.height) or attributes.height gt 0>
			<cfoutput>	HEIGHT="#attributes.height#"#Chr(13)#</cfoutput>
		</cfif>
		<cfif structKeyExists(attributes,"align")>
			<cfoutput>	ALIGN="#attributes.align#"#Chr(13)#</cfoutput>
		</cfif>
	<cfoutput>>
<PARAM NAME="CODE" VALUE="coldfusion.applets.CFTreeApplet.class">
<PARAM NAME="ARCHIVE" VALUE="#archive#">
<PARAM NAME="MAYSCRIPT" VALUE="true">
</cfoutput>
		<cfif structKeyExists(attributes, "lookandfeel")>
			<cfoutput><PARAM NAME="lookandfeel" VALUE="#attributes.lookandfeel#">#Chr(13)#</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes, "appendkey")>
			<cfoutput><PARAM NAME="APPENDKEY" VALUE="#attributes.appendkey#">#Chr(13)#</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes, "border")>
			<cfoutput><PARAM NAME="BORDER" VALUE="#attributes.border#">#Chr(13)#</cfoutput>	
	   	</cfif>	
		<cfif structKeyExists(attributes, "font")>
			<cfoutput><PARAM NAME="FONT" VALUE="#attributes.font#">#Chr(13)#</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes, "bold") and attributes.bold EQ "YES">
			<cfif structKeyExists(attributes, "italic") and attributes.italic EQ "YES">
				<cfoutput><PARAM NAME="FONTWEIGHT" VALUE="bold, italic">#Chr(13)#</cfoutput>	
			<cfelse>
				<cfoutput><PARAM NAME="FONTWEIGHT" VALUE="bold">#Chr(13)#</cfoutput>	
			</cfif>
		<cfelse>			
			<cfif structKeyExists(attributes, "italic") and attributes.italic EQ "YES">
				<cfoutput><PARAM NAME="FONTWEIGHT" VALUE="italic">#Chr(13)#</cfoutput>	
			<cfelse>
				<cfoutput><PARAM NAME="FONTWEIGHT" VALUE="">#Chr(13)#</cfoutput>	
			</cfif>
		</cfif>
		<cfif structKeyExists(attributes, "hscroll")>
			<cfoutput><PARAM NAME="HSCROLL" VALUE="#attributes.hscroll#">#Chr(13)#</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes,"value")>
			<cfoutput><PARAM NAME="VALUE" VALUE="#attributes.value#">#Chr(13)#</cfoutput>
		</cfif>		
		<cfif structKeyExists(attributes, "completepath")>
			<cfoutput><PARAM NAME="ROOT" VALUE="#attributes.completepath#">#Chr(13)#</cfoutput>	
	   	</cfif>
			<cfoutput><PARAM NAME="SEPARATOR" VALUE="#attributes.delimiter#">#Chr(13)#</cfoutput>	
	   	<cfif structKeyExists(attributes, "highlighthref")>
			<cfoutput><PARAM NAME="SHOWLINKS" VALUE="#attributes.highlighthref#">#Chr(13)#</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes, "vscroll")>
			<cfoutput><PARAM NAME="VSCROLL" VALUE="#attributes.vscroll#">#Chr(13)#</cfoutput>	
	   	</cfif>	
		<cfif TreeItems.length() gt 0>
			<cfoutput><PARAM NAME="TREEITEMS" VALUE="#urlEncodedFormat(TreeItems.toString(), "UTF-8")#">#Chr(13)#</cfoutput>	
		</cfif>
<cfoutput>
<PARAM NAME="CF_FORM_NAME" VALUE="#cfFormName#">
<PARAM NAME="CF_PARAM_NAME" VALUE="#hiddenFieldName#">
</cfoutput>
	    <cfoutput>#attributes.notSupported##chr(13)#</cfoutput>
<cfoutput></OBJECT></cfoutput>

<!-- Applet call for NN -->
<cfelse>
	<cfoutput>
	<EMBED
		TYPE="application/x-java-applet;version=1.3"
		PLUGINSPAGE="http://java.sun.com/j2se/1.3/jre/index.html"
		CODE="coldfusion.applets.CFTreeApplet.class"
		ARCHIVE="#archive#"
		MAYSCRIPT="true"
	</cfoutput>
		<cfif not isNumeric(attributes.width) or attributes.width gt 0>
			<cfoutput> WIDTH="#attributes.width#"</cfoutput>
		</cfif>
		<cfif not isNumeric(attributes.height) or attributes.height gt 0>
			<cfoutput> HEIGHT="#attributes.height#"</cfoutput>
		</cfif>
		<cfif structKeyExists(attributes, "align")>
			<cfoutput> ALIGN="#attributes.align#"</cfoutput>	
	 	</cfif>
		<cfif structKeyExists(attributes, "lookandfeel")>
			<cfoutput> LOOKANDFEEL="#attributes.lookandfeel#"</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes, "appendkey")>
			<cfoutput> APPENDKEY="#attributes.appendkey#"</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes, "border")>
			<cfoutput> BORDER="#attributes.border#"</cfoutput>	
	   	</cfif>	
		<cfif structKeyExists(attributes, "font")>
			<cfoutput> FONT="#attributes.font#"</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes, "hscroll")>
			<cfoutput> HSCROLL="#attributes.hscroll#"</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes, "completepath")>
			<cfoutput> ROOT="#attributes.completepath#"</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes, "delimiter")>
			<cfoutput> SEPERATOR"="#attributes.delimiter#"</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes, "highlighthref")>
			<cfoutput> SHOWLINKS="#attributes.highlighthref#"</cfoutput>	
	   	</cfif>
		<cfif structKeyExists(attributes,"value")>
			<cfoutput> VALUE="#attributes.value#"</cfoutput>
		</cfif>		
		<cfif structKeyExists(attributes, "bold") and attributes.bold EQ "YES">
			<cfif structKeyExists(attributes, "italic") and attributes.italic EQ "YES">
				<cfoutput> FONTWEIGHT="bold, italic"</cfoutput>		
			<cfelse>
				<cfoutput> FONTWEIGHT="bold"</cfoutput>	
			</cfif>
		<cfelse>			
			<cfif structKeyExists(attributes, "italic") and attributes.italic EQ "YES">
				<cfoutput> FONTWEIGHT="italic"</cfoutput>	
			<cfelse>
				<cfoutput> FONTWEIGHT=""</cfoutput>		
			</cfif>
		</cfif>
		<cfif structKeyExists(attributes, "vscroll")>
			<cfoutput> VSCROLL="#attributes.vscroll#"</cfoutput>	
	   	</cfif>	
		<cfif TreeItems.length() gt 0>
			<cfoutput> TREEITEMS="#urlEncodedFormat(TreeItems.toString(), "UTF-8")#"</cfoutput>	
		</cfif>
	<cfoutput>
	   	CF_FORM_NAME="#cfFormName#"
	    CF_PARAM_NAME="#hiddenFieldName#">
	</cfoutput>
	<cfoutput><NOEMBED></cfoutput>
	<cfoutput>#attributes.notSupported#</cfoutput>
	<cfoutput></NOEMBED>
	</EMBED>
	</cfoutput>
</cfif>

	
	</cfcase>
</cfswitch>

<cfsetting enableCFOutputOnly="FALSE">



